/**
 * Copyright (c) 2007, Opera Software ASA
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Opera Software ASA nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY OPERA SOFTWARE ASA AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL OPERA SOFTWARE ASA AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

function g(e){return document.getElementById(e);}

function makeWindowResizable()
{
  var width = parseInt(widget.preferenceForKey('width') || 600);
  var height = parseInt(widget.preferenceForKey('height') || 400);
  
  var resizeWindow = function()
  {
    width >>= 0;
    height >>= 0;
    
    if (width < 400) width = 400;
    if (height < 300) height = 300;
    
    widget.setPreferenceForKey(width,'width');
    widget.setPreferenceForKey(height,'height');
    
    if (!document.body.hasClass('minimized')) window.resizeTo(width,height);
    
    var HEAD_HEIGHT = 33;
    var PADDING = 28;
    var BOTTOM_BAR_HEIGHT = 27;
    g('wdgt-toc-container').style.height =
      g('wdgt-content').style.height =
      g('wdgt-config').style.height =
      (height-HEAD_HEIGHT-PADDING-BOTTOM_BAR_HEIGHT) + 'px';
  }
  
  resizeWindow();

  function poll(e0,x,y)
  {
    var top0 = window.screenTop;
    var left0 = window.screenLeft;
    var width0 = width;
    var height0 = height;
    document.onmousemove = function(e1)
    {
      var top = top0;
      var left = left0;
      
      if (x==1)
      {
        width = Math.min(screen.availWidth-left0, e1.clientX/e0.clientX*width0);
      }
      if (x==-1)
      {
        width = Math.min(left0 + width0, (width0 + left0 - e1.screenX) / (width0 + left0 - e0.screenX) * width0);
        left = (left0 + width0 - width) >> 0;
      }
      if (y==1)
      {
        height = Math.min(screen.availHeight-top0, e1.clientY/e0.clientY*height0);
      }
      if (y==-1)
      {
        height = Math.min(top0 + height0, (height0 + top0 - e1.screenY) / (height0 + top0 - e0.screenY) * height0);
        top = (top0 + height0 - height) >> 0;
      }
    
      resizeWindow();
      
      if (x==-1 || y==-1)
      {
        window.moveTo(left>>0, top>>0);
      }
    };
  }
  
  //g('block-right'      ).onmousedown = function(e){poll(e, 1, 0);};
  g('block-bottomright').onmousedown = function(e){poll(e, 1, 1);};
  //g('block-bottom'     ).onmousedown = function(e){poll(e, 0, 1);};
  g('block').onmousedown = function(e0)
  {
    if (e0.target != this) return;
    var top0 = window.screenTop;
    var left0 = window.screenLeft;
    document.onmousemove = function(e1)
    {
      top1 = top0 + e1.screenY - e0.screenY;
      left1 = left0 + e1.screenX - e0.screenX;
      top1 = Math.max(0, Math.min( top1, screen.availHeight - height) );
      left1 = Math.max(0, Math.min( left1, screen.availWidth - width) );
      window.moveTo(left1, top1);
    }
  }
  
  document.onmouseup = function()
  {
    document.onmousemove = null;
  };
  
}
